#ifndef __SQUIRREL_H
	#define __SQUIRREL_H

	#include "board.h"

	#define TMCSQUIRREL_GENERAL_CONF			0x00
	#define TMCSQUIRREL_REFERENCE_CONF			0x01
	#define TMCSQUIRREL_START_CONF				0x02
	#define TMCSQUIRREL_INPUT_FILT_CONF			0x03
	#define TMCSQUIRREL_SPIOUT_CONF				0x04
	#define TMCSQUIRREL_CURRENT_CONF			0x05
	#define TMCSQUIRREL_SCALE_VALUES			0x06
	#define TMCSQUIRREL_ENC_IN_CONF				0x07
	#define TMCSQUIRREL_ENC_IN_DATA				0x08
	#define TMCSQUIRREL_ENC_OUT_DATA			0x09
	#define TMCSQUIRREL_STEP_CONF				0x0A
	#define TMCSQUIRREL_SPI_STATUS_SELECTION	0x0B
	#define TMCSQUIRREL_EVENT_CLEAR_CONF		0x0C
	#define TMCSQUIRREL_INTR_CONF				0x0D
	#define TMCSQUIRREL_EVENTS					0x0E
	#define TMCSQUIRREL_STATUS					0x0F

	#define TMCSQUIRREL_STP_LENGTH_ADD			0x10
	#define TMCSQUIRREL_DIR_SETUP_TIME			0x11
	#define TMCSQUIRREL_START_OUT_ADD			0x12
	#define TMCSQUIRREL_START_DELAY				0x13
	#define TMCSQUIRREL_CLK_GATING_DELAY		0x14
	#define TMCSQUIRREL_STDBY_DELAY				0x15
	#define TMCSQUIRREL_FREEWHEEL_DELAY			0x16
	#define TMCSQUIRREL_VDRV_SCALE_LIMIT		0x17
	#define TMCSQUIRREL_PWM_VMAX				0x17
	#define TMCSQUIRREL_UP_SCALE_DELAY			0x18
	#define TMCSQUIRREL_CL_UPSCALE_DELAY		0x18
	#define TMCSQUIRREL_HOLD_SCALE_DELAY		0x19
	#define TMCSQUIRREL_CL_DOWNSCALE_DELAY		0x19
	#define TMCSQUIRREL_DRV_SCALE_DELAY			0x1A
	#define TMCSQUIRREL_BOOST_TIME				0x1B
	#define TMCSQUIRREL_CL_BETA					0x1C
	#define TMCSQUIRREL_CL_GAMMA				0x1C
	#define TMCSQUIRREL_DAC_ADDR_A				0x1D
	#define TMCSQUIRREL_DAC_ADDR_B				0x1D
	#define TMCSQUIRREL_HOME_SAFETY_MARGIN		0x1E
	#define TMCSQUIRREL_PWM_FREQ				0x1F
	#define TMCSQUIRREL_CHOPSYNC_DIV			0x1F

	#define TMCSQUIRREL_RAMPMODE				0x20
	#define TMCSQUIRREL_XACTUAL					0x21
	#define TMCSQUIRREL_VACTUAL					0x22
	#define TMCSQUIRREL_AACTUAL					0x23
	#define TMCSQUIRREL_VMAX					0x24
	#define TMCSQUIRREL_VSTART					0x25
	#define TMCSQUIRREL_VSTOP					0x26
	#define TMCSQUIRREL_VBREAK					0x27
	#define TMCSQUIRREL_AMAX					0x28
	#define TMCSQUIRREL_DMAX					0x29
	#define TMCSQUIRREL_ASTART					0x2A
	#define TMCSQUIRREL_DFINAL					0x2B
	#define TMCSQUIRREL_DSTOP					0x2C
	#define TMCSQUIRREL_BOW1					0x2D
	#define TMCSQUIRREL_BOW2					0x2E
	#define TMCSQUIRREL_BOW3					0x2F
	#define TMCSQUIRREL_BOW4					0x30
	#define TMCSQUIRREL_CLK_FREQ				0x31


	#define TMCSQUIRREL_POS_COMP				0x32
	#define TMCSQUIRREL_VIRT_STOP_LEFT			0x33
	#define TMCSQUIRREL_VIRT_STOP_RIGHT			0x34
	#define TMCSQUIRREL_X_HOME					0x35
	#define TMCSQUIRREL_X_LATCH					0x36
	#define TMCSQUIRREL_X_TARGET				0x37

	#define TMCSQUIRREL_X_PIPE0					0x38
	#define TMCSQUIRREL_X_PIPE1					0x39
	#define TMCSQUIRREL_X_PIPE2					0x3A
	#define TMCSQUIRREL_X_PIPE3					0x3B
	#define TMCSQUIRREL_X_PIPE4					0x3C
	#define TMCSQUIRREL_X_PIPE5					0x3D
	#define TMCSQUIRREL_X_PIPE6					0x3E
	#define TMCSQUIRREL_X_PIPE7					0x3F


	#define TMCSQUIRREL_SH_REG0					0x40
	#define TMCSQUIRREL_SH_REG1					0x41
	#define TMCSQUIRREL_SH_REG2					0x42
	#define TMCSQUIRREL_SH_REG3					0x43
	#define TMCSQUIRREL_SH_REG4					0x44
	#define TMCSQUIRREL_SH_REG5					0x45
	#define TMCSQUIRREL_SH_REG6					0x46
	#define TMCSQUIRREL_SH_REG7					0x47
	#define TMCSQUIRREL_SH_REG8					0x48
	#define TMCSQUIRREL_SH_REG9					0x49
	#define TMCSQUIRREL_SH_REG10				0x4A
	#define TMCSQUIRREL_SH_REG11				0x4B
	#define TMCSQUIRREL_SH_REG12				0x4C
	#define TMCSQUIRREL_SH_REG13				0x4D

	#define TMCSQUIRREL_DFREEZE					0x4E
	#define TMCSQUIRREL_IFREEZE					0x4E

	#define TMCSQUIRREL_CLK_GATING_REG			0x4F

	#define TMCSQUIRREL_ENC_POS					0x50
	#define TMCSQUIRREL_ENC_LATCH				0x51
	#define TMCSQUIRREL_ENC_RESET_VAL			0x51
	#define TMCSQUIRREL_ENC_POS_DEV				0x52
	#define TMCSQUIRREL_CL_TR_TOLERANCE 		0x52
	#define TMCSQUIRREL_ENC_POS_DEV_TOL			0x53
	#define TMCSQUIRREL_ENC_IN_RES				0x54
	#define TMCSQUIRREL_ENC_CONST				0x54
	#define TMCSQUIRREL_MANUAL_ENC_CONST0		0x54
	#define TMCSQUIRREL_ENC_OUT_RES				0x55
	#define TMCSQUIRREL_SER_CLK_IN_HIGH			0x56
	#define TMCSQUIRREL_SER_CLK_IN_LOW			0x56
	#define TMCSQUIRREL_SSI_IN_CLK_DELAY		0x57
	#define TMCSQUIRREL_BISS_TIMEOUT			0x57
	#define TMCSQUIRREL_SSI_IN_WTIME			0x57
	#define TMCSQUIRREL_BISS_IN_BUSYS			0x57
	#define TMCSQUIRREL_SSI_IN_PTIME			0x58
	#define TMCSQUIRREL_BISS_IN_BUSYR			0x58
	#define TMCSQUIRREL_CRC_GEN_POLYNOM			0x58

	#define TMCSQUIRREL_CL_OFFSET				0x59
	#define TMCSQUIRREL_PID_P					0x5A
	#define TMCSQUIRREL_CL_VMAX_CALC_P			0x5A
	#define TMCSQUIRREL_PID_VEL					0x5A
	#define TMCSQUIRREL_PID_I					0x5B
	#define TMCSQUIRREL_CL_VMAX_CALC_I			0x5B
	#define TMCSQUIRREL_PID_ISUM_RD				0x5B
	#define TMCSQUIRREL_PID_D					0x5C
	#define TMCSQUIRREL_CL_DELTA_P				0x5C
	#define TMCSQUIRREL_PID_I_CLIP				0x5D
	#define TMCSQUIRREL_PID_D_CLKDIV			0x5D
	#define TMCSQUIRREL_PID_E					0x5D
	#define TMCSQUIRREL_PID_DV_CLIP				0x5E
	#define TMCSQUIRREL_PID_TOLERANCE			0x5F
	#define TMCSQUIRREL_CL_TOLERANCE			0x5F

	#define TMCSQUIRREL_FS_VEL					0x60
	#define TMCSQUIRREL_DC_VEL					0x60
	#define TMCSQUIRREL_CL_VMIN_EMF				0x60


	#define TMCSQUIRREL_DCLSPTM_STP				0x61
	#define TMCSQUIRREL_CL_VADD_EMF				0x61
	#define TMCSQUIRREL_DC_LSPTM				0x62
	#define TMCSQUIRREL_ENC_VEL_ZERO			0x62
	#define TMCSQUIRREL_ENC_VMEAN_WAIT			0x63
	#define TMCSQUIRREL_ENC_VMEAN_FILTER		0x63
	#define TMCSQUIRREL_ENC_VMEAN_INT			0x63
	#define TMCSQUIRREL_DC_BLKTIME				0x64
	#define TMCSQUIRREL_SYNCHRO_SET				0x64
	#define TMCSQUIRREL_DC_SG 					0x64
	#define TMCSQUIRREL_V_ENC					0x65
	#define TMCSQUIRREL_V_ENC_MEAN				0x66
	#define TMCSQUIRREL_VSTALL_LIMIT			0x67

	#define TMCSQUIRREL_ADDR_TO_ENC				0x68
	#define TMCSQUIRREL_DATA_TO_ENC				0x69
	#define TMCSQUIRREL_ADDR_FROM_ENC			0x6A
	#define TMCSQUIRREL_DATA_FROM_ENC			0x6B
	#define TMCSQUIRREL_COVER_LOW				0x6C
	#define TMCSQUIRREL_COVER_HIGH				0x6D
	#define TMCSQUIRREL_COVER_DRV_LOW			0x6E
	#define TMCSQUIRREL_COVER_DRV_HIGH			0x6F

	#define TMCSQUIRREL_MSLUT_0					0x70
	#define TMCSQUIRREL_MSLUT_1					0x71
	#define TMCSQUIRREL_MSLUT_2					0x72
	#define TMCSQUIRREL_MSLUT_3					0x73
	#define TMCSQUIRREL_MSLUT_4					0x74
	#define TMCSQUIRREL_MSLUT_5					0x75
	#define TMCSQUIRREL_MSLUT_6					0x76
	#define TMCSQUIRREL_MSLUT_7					0x77
	#define TMCSQUIRREL_MSLUTSEL				0x78
	#define TMCSQUIRREL_MSCNT					0x79
	#define TMCSQUIRREL_CURRENTA				0x7A
	#define TMCSQUIRREL_CURRENTB				0x7A
	#define TMCSQUIRREL_CURRENTA_SPI			0x7B
	#define TMCSQUIRREL_CURRENTB_SPI			0x7B
	#define TMCSQUIRREL_SCALE_PARAM				0x7C
	#define TMCSQUIRREL_CIRCULAR_DEC 			0x7C
	#define TMCSQUIRREL_ENC_COMP_XOFFSET		0x7D
	#define TMCSQUIRREL_ENC_COMP_YOFFSET		0x7D
	#define TMCSQUIRREL_ENC_COMP_AMPL			0x7D

	#define TMCSQUIRREL_START_SIN				0x7E
	#define TMCSQUIRREL_START_SIN90_120			0x7E
	#define TMCSQUIRREL_DAC_OFFSET 				0x7E

	#define TMCSQUIRREL_COVER_DONE				(1<<25)

	#define TMCSQUIRREL_RAMP_HOLD				0
	#define TMCSQUIRREL_RAMP_TRAPEZ				1
	#define TMCSQUIRREL_RAMP_SSHAPE				2
	#define TMCSQUIRREL_RAMP_POSITION			4
	#define TMCSQUIRREL_RAMP_HOLD				0

	typedef struct
	{
		SPIChannelTypeDef *SPIChannel;
		int velocity;
		const uint8 registerAccess[128];
		void (*periodicJob)(uint32 tick);
		void (*writeDatagram)(unsigned char Address, unsigned char x1, unsigned char x2, unsigned char x3, unsigned char x4);
		void (*writeInt)(unsigned int address, int value);
		int (*readInt)(unsigned char Address);
		unsigned char (*cover)(unsigned char data, unsigned char lastTransfer);

		uint8  (*moveToNextFullstep)();
		uint8  (*calibrateClosedLoop)(uint8 start);
		uint8	moveRelativeBy;
		uint8	rampMode;
		uint8 status;

		ConfigurationTypeDef *config;
	} TMCSquirrelTypeDef;

	TMCSquirrelTypeDef TMCSquirrel;

#endif
